<?php

if ( ! defined('_PS_VERSION_')) {
    exit;
}

/**
 * Class MultiParcels_Shipping_Permissions
 */
class MultiParcels_Shipping_Permissions
{

    const CODE_NONE = 'none';

    const CODE_LIMITED = 'limited';

    const CODE_FULL = 'full';

    const CODES = [
        self::CODE_NONE,
        self::CODE_LIMITED,
        self::CODE_FULL,
    ];

    /**
     * @var \Multiparcelsshipping
     */
    private $module;

    /**
     * MultiParcels_Shipping_Permissions constructor.
     *
     * @param  \Multiparcelsshipping  $module
     */
    public function __construct(Multiparcelsshipping $module)
    {
        $this->module = $module;
    }

    public function get()
    {
        $code = $this->module->configuration->getPermissions();

        if ( ! in_array($code, [self::CODE_LIMITED, self::CODE_FULL])) {
            $code = self::CODE_NONE;
        }

        return $code;
    }

}
