<?php

if ( ! defined('_PS_VERSION_')) {
    exit;
}

/**
 * Class MultiParcels_Shipping_Setup
 */
class MultiParcels_Shipping_Setup
{

    /**
     * @var \Multiparcelsshipping
     */
    private $module;

    /**
     * MultiParcels_Shipping_Setup constructor.
     *
     * @param  \Multiparcelsshipping  $module
     */
    public function __construct(Multiparcelsshipping $module)
    {
        $this->module = $module;
    }

    public function install()
    {
        include(dirname(__FILE__).'/../sql/install.php');

        $result = null;

        // Multistore
        if (Shop::isFeatureActive()) {
            Shop::setContext( Shop::CONTEXT_ALL );
        }

        $hooks = Multiparcelsshipping::HOOKS;

        // remove not used hooks
        if (version_compare(_PS_VERSION_, '1.7.7', '>=')) {
            // (removed in 1.7.7 in favor of) → displayAdminOrderTabContent
            $find = array_search('displayAdminOrderContentShip', $hooks);
        } else {
            $find = array_search('displayAdminOrderTabContent', $hooks);
        }

        unset($hooks[$find]);

        foreach ($hooks as $hook) {
            $result = $this->module->registerHook($hook);

            if ( ! $result) {
                break;
            }
        }

        return $result;
    }

    public function uninstall()
    {
        // remove carriers
    }

}
