<?php

/**
 * 2007-2020 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 * @author    PrestaShop SA <contact@prestashop.com>
 * @copyright 2007-2020 PrestaShop SA
 * @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License
 *     (AFL 3.0) International Registered Trademark & Property of PrestaShop SA
 */
$sql = [];

$sql[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.Multiparcelsshipping::TABLE_LOCATIONS.'` (
        id mediumint(9) NOT NULL AUTO_INCREMENT,
		carrier_code VARCHAR(255) NOT NULL,
		identifier VARCHAR(255) NOT NULL,
		type VARCHAR(255) NOT NULL,
		name VARCHAR(255) NOT NULL,
		address VARCHAR(255) NOT NULL,
		postal_code VARCHAR(255) NOT NULL,
		city VARCHAR(255) NOT NULL,
		country_code VARCHAR(255) NOT NULL,
		latitude VARCHAR(255) NULL,
		longitude VARCHAR(255) NULL,
		comment VARCHAR(255) NULL,
		working_hours VARCHAR(255) NULL,
		UNIQUE KEY id (id),
		KEY carrier_code (carrier_code),
		KEY identifier (identifier)
) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';

$sql[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.Multiparcelsshipping::TABLE_CART.'` (
    id_cart int(10) NOT NULL,
    id_terminal varchar(20) NOT NULL,
    carrier_code varchar(255) NOT NULL,
		UNIQUE KEY id (id_cart)
) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';

$sql[] = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.Multiparcelsshipping::TABLE_CARRIER.'` (
    `id_carrier` int(10) NOT NULL,
    `carrier_code` varchar(20) NOT NULL,
    `type` varchar(20) NOT NULL,
		UNIQUE KEY id (id_carrier)
) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';

foreach ($sql as $query) {
    if (Db::getInstance()->execute($query) == false) {
        return false;
    }
}
