/**
 * 2007-2020 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    PrestaShop SA <contact@prestashop.com>
 *  @copyright 2007-2020 PrestaShop SA
 *  @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 *
 * Don't forget to prefix your containers with your own identifier
 * to avoid any conflicts with others containers.
 */

(function ($) {
    $('.multiparcels_shipping_terminal_select').select2({
        placeholderOption: 'first',
        width: '100%',
        language: {
            noResults: function () {
                return multiparcels.translations.pickup_location_not_found;
            }
        },
        templateResult: function (option) {
            if (!option.element || option.children) {
                return option.text;
            }

            var data = JSON.parse($(option.element).attr('data-json'));

            return $(
                '<span>' + data.first_line + ' <small>' + data.second_line + '</small></span>'
            );

            return $('<span>' + option.text + '</span>');
        },
        templateSelection: function (option, container) {
            if (!option.element) {
                return option.text;
            }

            var data = JSON.parse($(option.element).attr('data-json'));

            if (typeof data.second_line != 'undefined' && data.second_line) {
                return data.first_line + ' (' + data.second_line + ')';
            }

            return data.first_line;
        }
    });

    $('.multiparcels_shipping_terminal_select').on('change', function () {
        var element = $(this).find('option:selected');
        var location = JSON.parse($(element).attr('data-json'));

        var html = location['second_line'] + "<br/>";

        if (location.working_hours) {
            html += multiparcels.translations.working_hours + ": <strong>" + location.working_hours + "</strong><br/>";
        }

        if (location.comment) {
            html += "<small>" + location.comment + "</small><br/>";
        }

        $(this).parent().find('.multiparcels_shipping_terminal_selected_information').html(html).show();
    });
})(jQuery);

