(function () {
    var elementToWaitFor = '#collapse-shipping-method .panel-body';
    var checkout = 'default';
    var billingCountrySelector = '#input-payment-country';
    var shippingCountrySelector = '#input-shipping-country';
    var storage = null;
    var settings = {
        shippings: {}
    };

    if (typeof window['Journal'] == 'object') {
        elementToWaitFor = '.checkout-section.shipping-payment';
        checkout = 'journal';
    }

    $.ajax({
        url: 'index.php?route=extension/module/multiparcels/js',
        success: function (response) {

            if (response.checkout === 'ajax_quick_checkout') {
                checkout = 'ajax_quick_checkout';
                elementToWaitFor = '#d_quickcheckout #shipping_method_form';
            }

            if (response.checkout === 'ajax_quick_checkout7') {
                checkout = 'ajax_quick_checkout7';
                elementToWaitFor = '#d_quickcheckout #shipping_method_list';
            }

            if (response.checkout === 'ajax_quick_checkout' || response.checkout === 'ajax_quick_checkout7') {
                billingCountrySelector = '#payment_address_country_id';
                shippingCountrySelector = '#shipping_address_country_id';
            }

            settings = response;
            multiparcels_wait_for_element(elementToWaitFor, start_multiparcels);
        }
    });

    function multiparcels_wait_for_element(selector, callback) {
        var interval = setInterval(function () {
            element = jQuery(selector);
            if (!element.is(':visible')) {
                return;
            }
            clearInterval(interval);
            callback(element);
        }, 100);
    }

    var a = {
        \u0440: "a",
        \u010D: "c",
        \u0119: "e",
        \u0117: "e",
        \u012F: "i",
        \u0161: "s",
        \u0173: "u",
        \u016B: "u",
        \u017E: "z"
    };

    function transliterate(word) {
        return word.split('').map(function (char) {
            return a[char] || char;
        }).join("");
    }

    function multiparcelsElement() {
        var select = "<select id='multiparcels-pickup-point-select' name='multiparcels_location' style='width: 100%;'></select>";

        if (checkout === "default" || checkout === 'ajax_quick_checkout' || checkout === 'ajax_quick_checkout7') {
            select += "<input type='radio' value='' name='multiparcels_location' id='multiparcels-pickup-point-radio-location' style='display: none;' tabindex='-1' checked/>";
            select += "<input type='radio' value='' name='multiparcels_carrier' id='multiparcels-pickup-point-radio-courier' style='display: none;' tabindex='-1' checked/>";
        }

        return "<div id='multiparcels-holder' style='width: 250px;'>" + select + "</div>";
    }

    function findCarrier(text) {
        var found = null;
        text = transliterate(text).toLowerCase();

        for (var carrier in settings.shippings) {
            for (var wordsSet in settings.shippings[carrier]) {
                var words = settings.shippings[carrier][wordsSet];
                var requiredWords = words.length;
                var foundWords = 0;

                words.forEach(function (word) {
                    word = transliterate(word).toLowerCase();
                    if (text.indexOf(word) > -1) {
                        foundWords++;
                    }
                });

                if (requiredWords > 0 && requiredWords === foundWords) {
                    found = carrier;
                    break;
                }
            }
        }

        return found;
    }

    function start_multiparcels() {
        $(document).on('change', "[name='shipping_method'], " + billingCountrySelector, ", " + shippingCountrySelector, function () {
            $('#multiparcels-holder').remove();
            if (checkout === 'journal') {
                $('.multiparcels-journal-label-flex-direction-column').removeClass('multiparcels-journal-label-flex-direction-column');
            }
            if (checkout === 'ajax_quick_checkout' || checkout === 'ajax_quick_checkout7') {
                setTimeout(function () {
                    real_start_multiparcels();
                }, 500);
            } else {
                real_start_multiparcels();
            }
        });

        if (checkout === 'ajax_quick_checkout' || checkout === 'ajax_quick_checkout7') {
            setTimeout(function () {
                real_start_multiparcels();
            }, 500);
        } else {
            real_start_multiparcels();
        }
    }

    function real_start_multiparcels() {
        var selectedElement = $("[name='shipping_method']:checked");
        var selectedShippingLabel = selectedElement.parent().text();
        var carrier = findCarrier(selectedShippingLabel.trim());

        console.log(carrier);
        console.log(storage);


        if (checkout === 'ajax_quick_checkout7' && !carrier && storage) {
            $("[name='shipping_method']:checked").trigger('click'); // trigger save
        }

        if (!carrier) {
            return;
        }

        selectedElement.parent().after(multiparcelsElement());

        var element = $('#multiparcels-pickup-point-select');

        $("#multiparcels-holder").addClass('multiparcels-loading');

        var options = '';
        options += "<option value=''></option>";
        element.html(options);

        if (checkout === 'journal') {
            element.parent().parent().addClass('multiparcels-journal-label-flex-direction-column');
        }

        var country = $(billingCountrySelector).val();
        var shippingCountry = $(shippingCountrySelector).val();

        if (shippingCountry) {
            country = shippingCountry;
        }

        $.ajax({
            url: 'index.php?route=extension/module/multiparcels/locations&carrier=' + carrier + '&country=' + country,
            success: function (response) {
                window.multiparcels = response.global_variable;

                element.select2({
                    data: response.locations,
                    placeholderOption: 'first',
                    width: '100%',
                    language: {
                        noResults: function () {
                            return multiparcels.translations.pickup_location_not_found;
                        }
                    },
                    templateResult: function (option) {
                        return $(
                            '<span>' + option.first_line + '<br/><small>' + option.second_line + '</small></span>'
                        );
                    },
                    templateSelection: function (data, container) {
                        return data.first_line;
                    }
                });

                $("#multiparcels-holder").removeClass('multiparcels-loading');
            }
        });

        element.on('change', function () {
            var value = $(this).val();

            if (checkout === 'default' || checkout === 'ajax_quick_checkout' || checkout === 'ajax_quick_checkout7') {
                $("#multiparcels-pickup-point-radio-location").val(value);
                $("#multiparcels-pickup-point-radio-courier").val(carrier);
            } else if (checkout === 'journal') {
                window['_QuickCheckoutData']['order_data']['multiparcels_location'] = value;
                window['_QuickCheckoutData']['order_data']['multiparcels_courier'] = carrier;
            }

            if (checkout === 'ajax_quick_checkout7') {
                $("[name='shipping_method']:checked").trigger('click'); // trigger save
                storage = value;
            }
        });
    }
})();
